package org.expeditee.items;

import javax.swing.JComboBox;

public class SampleWidget1 extends InteractiveWidget {
	
	static String testItems[] = new String[] {"dog", "fish", "cat", "pig"};
	
	private JComboBox _combo;
	
	public SampleWidget1(Text source, String[] args) {
		super(source, new JComboBox(testItems), 200, 200, 50, 50);
		_combo = (JComboBox)super._swingComponent;

		// Set state
		if (args != null) {
			
			int selectedItem = 0;
			
			// extract selected index
			if (args.length >= 1 && args[0] != null) {
				try {
					selectedItem = Integer.parseInt(args[0]);
				} catch (NumberFormatException e) {
					e.printStackTrace();
				}
			}
			
			// Get defined items
			if (args.length >= 2) {
				_combo.removeAllItems();
				for (int i = 1; i < args.length; i++) {
					if (args[i] != null) _combo.addItem(args[i]);
				}
				if (_combo.getItemCount() == 0) {
					for (String s : testItems) _combo.addItem(s);
				}
			}
			
			if (selectedItem < 0) selectedItem = 0;
			else if (selectedItem >= _combo.getItemCount()) 
				selectedItem = _combo.getItemCount() - 1;
			_combo.setSelectedIndex(selectedItem);
			
		}
		
		
	}

	@Override
	protected String[] getArgs(boolean isCopy) {
		
		String[] stateArgs = new String[_combo.getItemCount() + 1];
		stateArgs[0] = Integer.toString(_combo.getSelectedIndex());
		for (int i = 0; i < _combo.getItemCount(); i++) {
			stateArgs[i + 1] = _combo.getItemAt(i).toString();
		}
		
		return stateArgs;
	}
	
	@Override
	protected String getTopMostClassName() {
		return getClass().getName();
	}
	


}
